package com.laguerre.kan;

public final class Light extends Behaviour {
	public static final int RENDERING_MODE_IMPORTANT = 0;
	public static final int RENDERING_MODE_NOT_IMPORTANT = 1;

	public static final int DIRECTIONAL = 0;
	public static final int POINT = 1;
	public static final int SPOT = 2;

	private int lightType = POINT;
	private int renderingMode = RENDERING_MODE_NOT_IMPORTANT;
	private final Color diffuseColor = Color.getNewBlack();
	private final Color specularColor = Color.getNewBlack();
	private float range = -0.1f;
	private float innerCutOffAngleDeg = 10f;
	private float outerCutOffAngleDeg = 15f;

	Light() {
	}

	public void setLightType(int lightType) {
		this.lightType = lightType;
	}

	public int getLightType() {
		return this.lightType;
	}

	public void setRenderingMode(int renderingMode) {
		this.renderingMode = renderingMode;
	}

	public int getRenderingMode() {
		return this.renderingMode;
	}

	public void setDiffuseColor(float r, float g, float b, float a) {
		this.diffuseColor.setValues(r, g, b, a);
	}

	public void setDiffuseColor(Color c) {
		this.diffuseColor.setValues(c);
	}

	public Color getSharedDiffuseColor() {
		return this.diffuseColor;
	}

	public void setSpecularColor(float r, float g, float b, float a) {
		this.specularColor.setValues(r, g, b, a);
	}

	public void setSpecularColor(Color c) {
		this.specularColor.setValues(c);
	}

	public Color getSharedSpecularColor() {
		return this.specularColor;
	}

	public void setRange(float range) {
		this.range = range;
	}

	public float getRange() {
		return this.range;
	}

	public void setInnerCutOffAngle(float innerCutOffAngleDeg) {
		this.innerCutOffAngleDeg = innerCutOffAngleDeg;
	}

	public float getInnerCutOffAngle() {
		return this.innerCutOffAngleDeg;
	}

	public void setOuterCutOffAngle(float outerCutOffAngleDeg) {
		this.outerCutOffAngleDeg = outerCutOffAngleDeg;
	}

	public float getOuterCutOffAngle() {
		return this.outerCutOffAngleDeg;
	}
}
